import processing.serial.*; // Bibliothek für serielle Kommunikation
import java.awt.event.KeyEvent; // Bibliothek für Lesen der Information
import java.io.IOException;
Serial Port; 
 
String breiteX = "";
String laengeZ = "";
String hoeheY = "";
String daten = "";
float X, Y, Z;
int index1 = 0;
int index2 = 0;
int index3 = 0;

 
int f = 10; //Variable Faktor 
float rotX, rotY;
void setup() {
  size(1200, 800, OPENGL);
  String portName = Serial.list()[Serial.list().length-1];
  Port = new Serial(this, portName, 9600); // Serielle Kommunikation starten
  Port.bufferUntil('.'); // ließt daten bis zum Punkt, also laengeZ, breiteX, hoheY

}
 
void draw() {  
  background(32);

  lights(); // Schatten
 
  fill(/*#FF9F03*/random(255));
  noStroke();
 
  serial(Port);
  translate(width/2, height/2); //Objekt in Bildmitte schieben
  rotateX(rotX);
  rotateY(-rotY); 
  box(X * f, Y* f, Z * f); //Maße werden mit einem vorher definierten Faktor multipliziert um das Objekt später gut erkennen zu können
  // Um Maße als Text aus zugeben:
  /*  String s = "Breite:" + X;
   String d = "Hoehe:" + Y;
   String D = "Laenge:" + Z;
   fill(300);
   text(s, 10, 10, 70, 80);  
   text(d, 20, 30, 70, 80);
   text(D, 30, 60, 70, 80);*/
 
}
 
void mouseDragged() { //Funktion um mit der Maus das Objekt zu drehen
  rotY -= (mouseX - pmouseX) * 0.01;
  rotX -= (mouseY - pmouseY) * 0.01;
}
 
void serial (Serial Port) { // Anfangen daten vom seriellen Port einzulesen
  if (Port.available() > 0) {
    //Bis '.' alles lesen und in daten speichern
    daten = Port.readStringUntil(';');
    daten = daten.substring(0, daten.length()-1);
    System.out.println(daten.toString());
    index1 = daten.indexOf(","); // ',' finden und in "index1" speichern
    System.out.println(index1);
    breiteX= daten.substring(0, index1); 
    index2 = daten.substring(index1+1, daten.length()-1).indexOf(",")+index1;
    System.out.println(breiteX);
    laengeZ= daten.substring(index1+1, index2+1);
    
    System.out.println(laengeZ);
    hoeheY = daten.substring(index2+2, daten.length()); 
    System.out.println(hoeheY);
    // String Variable in float konvertieren
    X = float(breiteX);
    Z = float(laengeZ);
    Y = float(hoeheY);
  }
}
//Teile vom Code könnten von https://howtomechatronics.com/projects/arduino-radar-project/   sein
